import HumanAgent from "./agents/HumanAgent.js";
import MarioGame from "./engine/core/MarioGame.js";
import Replay from "./engine/helper/Replay.js";

async function getLevel(filepath) {
    let response = await fetch(filepath)
    return await response.text()
}

async function getAgent(repPath){
    return Replay.getRepAgentFromFile(repPath);
}

let game = new MarioGame()
game.setLives(5)
// let levelPath = "../levels/original/lvl-1.txt";			// For local
let levelPath = "./levels/lvl73.lvl";			// For local
let repPath = "./reps/b179cbd3-ee8e-48de-baf8-da6438461d1d_lvl155.rep";
// let level = await getLevel(levelPath)


const level = `----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------g-----------------------------------------------------------------------------------------------------------------------
----------------------!---------------------------------------------------------SSSSSSSS---SSS!--------------@-----------SSS----S!!S--------------------------------------------------------##------------
-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------###------------
-------------------------------------------------------------------------------g----------------------------------------------------------------------------------------------------------####------------
----------------------------------------------------------------1------------------------------------------------------------------------------------------------------------------------#####------------
----------------!---S@S!S---------------------tt---------tt------------------S@S--------------C-----SU----!--!--!-----S----------SS------#--#----------##--#------------SS!S------------######------------
--------------------------------------tt------tt---------tt-----------------------------------------------------------------------------##--##--------###--##--------------------------#######------------
----------------------------tt--------tt------tt---------tt----------------------------------------------------------------------------###--###------####--###-----tt--------------tt-########--------F---
---M-----------------g------tt--------tt-g----tt-----g-g-tt------------------------------------g-g--------k-----------------gg-g-g----####--####----#####--####----tt---------gg---tt#########--------#---
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX--XXXXXXXXXXXXXXX---XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX--XXXXXXXXXXXXXXX---XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX--XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX`

// let agent = await getAgent(repPath)
let agent = new HumanAgent()
// let agent = null;
let result = game.playGame(agent, level, 60, repPath, 30)
